#include "crash82.inc"


.db	"The Tower of Hanoi - TCPA",0


Pile1 = TEXT_MEM        ;Number of bricks, Size of bricks
Pile2 = Pile1+11
Pile3 = Pile2+11
Temp =  Pile3+11            ;Pile XCoord, which brick, which size
PP =	Temp+5			;Picked piece
From =	PP+1
NoM =	From+1			;Number of moves
Counter =	NoM+2
PXCoord =	Counter+1
XCoord =	PXCoord+1
YCoord =	XCoord+1


start:
        ;bcall(_indicatorOff)
	res 2,(iy+13)


Message:
        ld hl,Pile1
        ld de,Pile1+1
        ld bc,50
        ld (hl),0
        ldir

        ROM_CALL(CLEARLCD)
	call cleargbuf
	ld hl,Pic
	ld de,GRAPH_MEM
	ld bc,96
	ldir

	set 7,(iy+20)

DispBlocks:
	ld hl,Author
	ld bc,51*256+11
	ld (CURSOR_X),bc
	ROM_CALL(D_ZM_STR)
	ld bc,57*256+11
	ld (CURSOR_X),bc
	ROM_CALL(D_ZM_STR)
	ld bc,11*256+1
	ld (CURSOR_X),bc
	ROM_CALL(D_ZM_STR)
	ld bc,29*256+1
	ld (CURSOR_X),bc
	ROM_CALL(D_ZM_STR)

	ld hl,GRAPH_MEM+228			;$FD30
	ld d,h
	ld e,l
	ld a,%01111111
	ld (hl),a
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,10
	ldir

	ld de,GRAPH_MEM+335			;$FDBF
	inc hl
	ld bc,12
	lddr

	ld hl,GRAPH_MEM+240			;$FD40
	ld d,h
	ld e,l
	ld a,$80
	ld (hl),a
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,82
	ldir

	ld hl,GRAPH_MEM+446			;$FE54
	ld d,h
	ld e,l
	ld a,%01111111
	ld (hl),a
	ld a,255
	inc hl
	ld (hl),a
	inc hl
	ld (hl),a
	inc hl
	ld a,%11111110
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,4
	ldir

	ld hl,GRAPH_MEM+574			;$FEFC
	ex de,hl
	ld bc,9
	lddr

	ld hl,GRAPH_MEM+458			;$FE64
	ld d,h
	ld e,l
	ld a,%10000000
	ld (hl),a
	inc hl
	inc hl
	inc hl
	rlca
	ld (hl),a
	inc hl
	ex de,hl
	ld bc,4
	ldir

	ld hl,GRAPH_MEM+456			;$FE60
	ld de,GRAPH_MEM+468			;$FE70
	ld bc,94
	ldir

DispNumbers:
	ld hl,$14FB
	ld (CURSOR_X),hl
	ld c,2
	ld b,6
DNLoop
	ld a,(CURSOR_X)
	add a,12
	ld (CURSOR_X),a
	inc c
	ld a,c
	add a,'0'
	ROM_CALL(M_CHARPUT)
	djnz DNLoop
	
	ld hl,39*256+20
	ld (CURSOR_X),hl
	ld hl,NormalTxt
	ROM_CALL(D_ZM_STR)
	ld a,(CURSOR_X)
	add a,7
	ld (CURSOR_X),a
	ROM_CALL(D_ZM_STR)


	ld a,(CMode)
	call BigInvert

	ld a,(Blocks)
	call Select

	call Stupid2

MessageLoop:
	call Stupid
MessageLoopB:
	call CR_GRBCopy
MessageLoopC:
	call GET_KEY
	cp G_LEFT
	jr z,DecNoB
	cp G_DOWN
	jr z,SelectMode
	cp G_CLEAR
	ret z
	cp G_MODE
	ret z
	cp G_ENTER
	jr z,StartGame
	cp G_RIGHT
	jr nz,MessageLoopC

IncNoB:
	ld a,(Blocks)
	cp 8
	jr z,MessageLoopB
	inc a
	ld (Blocks),a
	dec a
Common:
	call Select
	ld a,(Blocks)
	call Select
	jr MessageLoopB

DecNoB:
	ld a,(Blocks)
	cp 3
	jr z,MessageLoopB
	dec a
	ld (Blocks),a
	inc a
	jr Common

SelectMode:
	call Stupid
SelectModeLoop:
	call CR_GRBCopy
SelectModeLoopB:
	call GET_KEY
	;cp G_DOWN
	;jr z,StartGame
	cp G_ENTER
	jr z,StartGame
	cp G_RIGHT
	jr z,SetMode
	cp G_UP
	jr z,MessageLoop
	cp G_CLEAR
	ret z
	cp G_LEFT
	jr nz,SelectModeLoopB

SetMode:
	ld a,(CMode)
	call BigInvert
	ld a,(CMode)
	xor 1
	ld (CMode),a
	call BigInvert
	jr SelectModeLoop

StartGame
	ld a,(CMode)
	or a
	jr z,Begin
	jp Puzzle

cleargbuf:
	ld hl,GRAPH_MEM
	ld d,h
	ld e,l
	inc de
	ld (hl),0
	ld bc,767
	ldir
	ret

Begin:
	ROM_CALL(CLEARLCD)
	call cleargbuf


	ld hl,Pile1
	ld a,(Blocks)
    ld (hl),a
    inc hl
    ld b,a
Loop:
    ld (hl),a
    dec a
    inc hl
    djnz Loop
Loopend:
	ld a,-16
	ld (PXCoord),a
    call DrawFirst
        
Move:
	ld a,-16
	ld (PXCoord),a
	call GET_KEY
	cp G_MODE
	jp z,EndRound
	cp G_YEDIT
	jr z,FromLeftRoutine
	cp G_ZOOM
	jr z,FromMiddleRoutine
	cp G_GRAPH
	jr nz,Move

FromRightRoutine:
	ld a,2
	ld (From),a
	jr FromRoutine

FromMiddleRoutine:
	ld a,1
	ld (From),a
	jr FromRoutine

FromLeftRoutine:
	ld a,0
	ld (From),a

FromRoutine:
	ld l,7
	ld b,a
	add a,a		;*2
	add a,a		;*4
	add a,b		;*5
	add a,3
	ld h,a
	sub 3
	add a,a		;*10
	add a,b		;*11
	ld (CURSOR_ROW),hl
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	ld a,6
	ROM_CALL(TX_CHARPUT)
	ld c,(hl)
	xor a
	cp c
	jr z,MoveNot
	dec (hl)
	ld b,0
	add hl,bc
	ld a,(hl)
	ld (PP),a
	xor a
	ld (hl),a
	jr To
MoveNot:
	call DrawFirst
	jr Move

To:
	call GET_KEY
	cp G_MODE
	jp z,EndRound
	cp G_YEDIT
	jr z,ToLeftRoutine
	cp G_ZOOM
	jr z,ToMiddleRoutine
	cp G_GRAPH
	jr nz,To


ToRightRoutine:
	ld a,2
	jr ToRoutine

ToMiddleRoutine:
	ld a,1
	jr ToRoutine

ToLeftRoutine:
	ld a,0

ToRoutine:
	ld b,a
	ld a,(From)
	cp b
	jr z,CouldntMove
	ld a,b
	add a,a		;*2
	add a,a		;*4
	ld c,a
	add a,a		;*8
	add a,c		;*12
	sub b		;*11
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	ld d,h
	ld e,l
	ld c,(hl)
	xor a
	cp c
	jr nz,NotZ
	inc hl
NotZ:
	ld b,0
	add hl,bc
	ld b,(hl)
	xor a
	cp b
	jr z,Zero
	ld a,(PP)
	cp b
	jr nc,CouldntMove
Zero:
	ld h,d
	ld l,e
	inc (hl)
	ld c,(hl)
	ld b,0
	add hl,bc
	ld a,(PP)
	ld (hl),a
	ld hl,(NoM)
	inc hl
	ld (NoM),hl
	call DrawFirst

CheckDone:
	ld hl,Pile2
	ld a,(Blocks)
	ld b,(hl)
	cp b
	jr z,Done
	ld hl,Pile3
	ld a,(Blocks)
	ld b,(hl)
	cp b
	jr z,Done
	jp Move

CouldntMove:
	ld a,(From)
	ld b,a
	add a,a
	add a,b
	add a,a
	add a,a
	sub b
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
CMRoutine:
	inc (hl)
	ld c,(hl)
	ld b,0
	add hl,bc
	ld a,(PP)
	ld (hl),a
	call DrawFirst
	jp Move

Done:
	ld hl,$0001
	ld (CURSOR_ROW),hl
	ld hl,Congrats
	ROM_CALL(D_ZT_STR)
Label:
	call GET_KEY
	cp G_ENTER
	jr nz,Label
	jp Message



DrawFirst:
	call cleargbuf
        ld hl,Pile1-1
DrawPile1:
        ld a,0
        ld (Temp+1),a
        inc hl
        ld b,10
        ld a,(PXCoord)
        add a,32
        ld (PXCoord),a
DrawP1Loop:
        push bc
        ld a,(Temp+1)
        inc a
        ld (Temp+1),a
        inc hl
        ld a,(hl)
        push hl
        call CheckSize
        pop hl
        pop bc
        djnz DrawP1Loop
        ld a,(Counter)
        inc a
        ld (Counter),a
        cp 3
        jr nz,DrawPile1

Return:
	ld hl,(NoM)
	ld bc,0
	ld (CURSOR_X),bc
	ld (CURSOR_ROW),bc
	ROM_CALL(D_HL_DECI)
	ld hl,$8028
	ROM_CALL(D_ZM_STR)
	xor a
	ld (Counter),a
	ld b,4
	ld hl,Temp
RetLoop:
	ld (hl),a
	inc hl
	djnz RetLoop

	call CR_GRBCopy

	ret

CheckSize:
        or a
        jr z,DrawPin

        ld (Temp+2),a
        ld a,(Temp+1)
		add a,a
		add a,a
        ld b,a
        ld a,63
        sub b
	;add a,12
        ld (YCoord),a
        call PutItOut
        ret

DrawPin:
        ld a,(PXCoord)
        dec a
        ld (XCoord),a
        ld a,(Temp+1)
		add a,a
		add a,a
        ld b,a
        ld a,63
        sub b
	;add a,12
        ld (YCoord),a
        ld a,(YCoord)
        ld b,4
        sub b
        ld d,a
        ld (YCoord),a
        ld c,4
PinYLoop:        
        ld b,2
        ld a,(YCoord)
        dec a
        ld (YCoord),a
        ld a,(XCoord)
        ld e,a

PinXLoop:
        call PutPixel
        inc e
        djnz PinXLoop
        dec c
        jr nz,PinYLoop
        ret
        
PutItOut:
        ld a,(Temp+2)
        add a,a
        ld b,a
        ld a,(PXCoord)
        sub b
        ld e,a
        ld (XCoord),a
        ld a,(YCoord)
        ld b,8
        sub b
        ld d,a
        ld (YCoord),a
        push de
        ld a,(Temp+2)
		add a,a
		add a,a
        ld b,a
        ld c,3
YLoop:
        ld a,(YCoord)
        inc a
        ld (YCoord),a
        ld a,(Temp+2)
		add a,a
		add a,a
        ld b,a
        ld a,(XCoord)
        ld e,a

XLoop:
        call PutPixel
        inc e
        djnz XLoop
        dec c
        jr nz,YLoop
        pop de
        ret

PutPixel:
        push bc
	push de
        ld a,(YCoord)
        ;ld c,e
	ld c,a
	ld b,e
        call FindPix
        or (hl)
        ld (hl),a
	pop de
        pop bc
        ret

Random:
	ld a,3
	push bc
	push de
	push hl
	ld b,a
	ld a,r
	add a,a
	ld hl,0
	ld d,0
	ld e,a
RMul:
	add hl,de
	djnz RMul
	ld a,h
	pop hl
	pop de
	pop bc
	ret

Puzzle:
	ld a,(Blocks)
	ld b,a
PuzzleLoop:
	push bc
	ld b,3
	call Random
	pop bc
	ld e,a
	add a,a	;*2
	add a,e	;*3
	add a,a	;*6
	add a,a	;*12
	sub e	;*11
	ld e,a
	ld d,0
	ld hl,Pile1
	add hl,de
	inc (hl)
	ld e,(hl)
	add hl,de
	ld (hl),b	
	djnz PuzzleLoop
	jp Loopend

EndRound:
	ROM_CALL(CLEARLCD)
	jp Message

Select:
	sub 3
	add a,a
	ld e,a
	ld d,0
	ld hl,GRAPH_MEM+240			;228
	add hl,de
	ld de,11
	ld b,7					;9
Invert:
	ld a,(hl)
	xor %01111111	;cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	xor %11111110	;cpl
	ld (hl),a
	add hl,de
	djnz Invert
	ret



BigInvert:
	add a,a
	add a,a
	add a,4
	ld e,a
	ld d,0
	ld hl,GRAPH_MEM+454			;442
	add hl,de
	ld de,9
	ld b,9					;11
BInvert:
	ld a,(hl)
	xor %01111111	;cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	ld a,(hl)
	xor %11111110	;cpl
	ld (hl),a
	add hl,de
	djnz BInvert
	ret


Stupid:
	ld hl,GRAPH_MEM+132		;$FCB0
	call SelectWhat
Stupid2:
	ld hl,GRAPH_MEM+348		;$FDD0
SelectWhat:
	ld de,8
	ld c,7
ThisLoop:
	ld b,4
SmthLoop:
	ld a,(hl)
	cpl
	ld (hl),a
	inc hl
	djnz SmthLoop
	add hl,de
	dec c
	jr nz,ThisLoop
	ret

FindPix:                        ; Same as FIND_PIXEL but maybe faster
  LD  A, B                      ; Save B (real X val)
  LD  B, 0
  LD  H, B
  LD  L, C
  ADD HL, HL
  ADD HL, BC
  ADD HL, HL
  ADD HL, HL
  LD  C, A
  SRL C
  SRL C
  SRL C
  ADD HL, BC
  LD  BC, GRAPH_MEM
  ADD HL, BC
  LD  B, %10000000
  AND %00000111
  JR  Z, GetPixDone
  LD  C, A
  LD  A, B
  LD  B, C
ShloopGetPix:
  RRA
  DJNZ ShloopGetPix
  ret
GetPixDone:
  ld a,b
  ret


Pic:
  .db %11111111,%11111111,%00010111,%11111100,%01111111,%11111111,%11111111,%11110110,%10111111,%11111110,%11111111,%11111111
  .db %11111111,%11111111,%10110111,%11111110,%11111111,%11111111,%11111111,%11101110,%10111111,%11111111,%11111111,%11111111
  .db %11111111,%11111111,%10110011,%10111110,%11101101,%01011011,%00111110,%11000110,%10110110,%01110110,%11111111,%11111111
  .db %11111111,%11111111,%10110101,%01011110,%11010101,%01010101,%01011101,%01101110,%00101010,%10101010,%11111111,%11111111
  .db %11111111,%11111111,%10110101,%00011110,%11010101,%01010001,%01011101,%01101110,%10110010,%10101010,%11111111,%11111111
  .db %11111111,%11111111,%10110101,%01111110,%11010110,%10110111,%01111101,%01101110,%10101010,%10101010,%11111111,%11111111
  .db %11111111,%11111111,%10110101,%01011110,%11010110,%10110101,%01111101,%01101110,%10101010,%10101010,%11111111,%11111111
  .db %11111111,%11111111,%10110101,%10111110,%11101110,%10111011,%01111110,%11101110,%10110010,%10110110,%11111111,%11111111




NormalTxt:	.db "Normal",0
PuzzleTxt:	.db "Puzzle",0

CMode:	.db 0
Blocks:	.db 3

Author:
	.db "Made by Andreas Finne",0
Email:
	.db "a_finne@hotmail.com",0

Numbertxt:	.db "Blocks:",0
Modetxt:	.db "Mode:",0

Congrats:	.db "Congratulations!",0


